<script lang="ts" setup name="CustomerList">
import { getCurrentInstance, ref } from 'vue'
import type { Ref } from 'vue'
import type { DateModelType } from 'element-plus'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import RollbackDialog from './../components/rollbackDialog.vue'
import type { ILabQuery, ITaskList, ITaskQuery } from '@/views/business/schedule/task/task-interface'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { printJSON } from '@/utils/printUtils'
import { exportFile } from '@/utils/exportUtils'
import { getDictByCode } from '@/api/system/dict'
import { getMyMeasureList } from '@/api/business/task'
import type { dictType } from '@/global'
const { proxy } = getCurrentInstance() as any
const $router = useRouter()
// 右上角按钮
const menus = [
  { name: '待检测', value: '2' },
  { name: '检测中', value: '3' },
  { name: '检测完', value: '4' },
]
const currentMenu = ref('2') // 当前选中状态
// 查询条件
const timeRange = ref<[DateModelType, DateModelType]>(['', ''])
const listQuery: Ref<ILabQuery> = ref({
  sampleNo: '', // 样品编号
  sampleName: '', // 样品名称
  orderNo: '', // 委托书编号
  customerNo: '', // 委托方代码
  customerName: '', // 委托方名称
  isUrgent: '', // 是否加急
  sampleBelong: '', // 样品属性
  startTime: '', // 应检完时间-开始
  endTime: '', // 应检完时间-结束
  measureStatus: '2', // 检测状态
  offset: 1,
  limit: 20,
})
// --------------获取所需字典值----------------
const sampleBelongList = ref<dictType[]>([]) // 样品属性列表
function getDict() {
  // 获取样品属性
  getDictByCode('sampleBelong').then((response) => {
    sampleBelongList.value = response.data
  })
}
getDict()

// 表头
const columns = ref<TableColumn[]>([
  { text: '样品编号', value: 'sampleNo', width: '110', align: 'center' },
  { text: '样品名称', value: 'sampleName', width: '120', align: 'center' },
  { text: '型号', value: 'sampleModel', align: 'center' },
  { text: '出厂编号', value: 'manufacturingNo', align: 'center' },
  { text: '委托书编号', value: 'orderNo', align: 'center' },
  { text: '委托方代码', value: 'customerNo', align: 'center' },
  { text: '委托方名称', value: 'customerName', align: 'center' },
  { text: '是否加急', value: 'isUrgentName', align: 'center', width: '55px', styleFilter: (row: ITaskList) => { return row.isUrgentName == '是' ? 'color: red' : '' } },
  { text: '应检完时间', value: 'requireOverTime', align: 'center', width: '110px' },
  { text: '样品属性', value: 'sampleBelongName', align: 'center' },
  { text: '当前检定环节', value: 'currentMeasureStateName', align: 'center', width: '80px' },
  // { text: '证书出具', value: 'certificationState', align: 'center', filter: (row: ITaskList) => { return `${row.currentCertifications}/${row.requireCertifications}` } },
])
// 表格数据
const list = ref<ITaskList[]>([])
// 总数
const total = ref(0)
// 表格加载状态
const loadingTable = ref(false)
// 选中的内容
const checkoutList = ref<string[]>([])

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getMyMeasureList(listQuery.value).then((res) => {
    list.value = res.data.rows.map((item: ITaskList) => {
      item.isUrgentName = item.isUrgent == 1 ? '是' : '否'
      return item
    })
    total.value = res.total
    loadingTable.value = false
  })
}
// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}

// 点击搜索
const searchList = () => {
  fetchData(true)
}
// 点击重置
const clearList = () => {
  listQuery.value = {
    sampleNo: '', // 样品编号
    sampleName: '', // 样品名称
    orderNo: '', // 委托书编号
    customerNo: '', // 委托方代码
    customerName: '', // 委托方名称
    isUrgent: '', // 是否加急
    sampleBelong: '', // 样品属性
    startTime: '', // 应检完时间-开始
    endTime: '', // 应检完时间-结束
    measureStatus: listQuery.value.measureStatus, // 检测状态
    offset: 1,
    limit: 20,
  }
}
// 点击详情
const handleDetail = (row: ITaskList) => {
  $router.push(`/schedule/task/distribute/${row.sampleId}`)
}

// 点击分发， 弹窗
const distributeDialogRef = ref()
const handleDistribute = (row: ITaskList) => {
  distributeDialogRef.value.initDialog(row.orderId, row.sampleId)
}
// 点击标签绑定
const barCodeBind = ref()
const bindLabel = (row: ITaskList) => {
  barCodeBind.value.initDialog(row.sampleId)
}
// 标签绑定完成
const bindLabelOver = () => {
  searchList()
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// 导出
const exportAll = () => {
  const loading = ElLoading.service({
    lock: true,
    text: '下载中请稍后',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (list.value.length > 0) {
    // const params = {
    //   bussinessSize: listQuery.value.bussinessSize, // 业务规模
    //   customerName: listQuery.value.customerName, // 公司名称
    //   customerNo: listQuery.value.customerNo, // 任务分发编号
    //   grade: listQuery.value.grade, // 履约评级
    //   ids: checkoutList.value,
    // }
    // exportCustomerList(params).then((res) => {
    //   const blob = new Blob([res.data])
    //   exportFile(blob, '任务分发列表.xlsx')
    // })
  }
  else {
    ElMessage.warning('无数据可导出数据')
  }
  loading.close()
}

// 打印列表
function printList() {
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (checkoutList.value.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '我的检测列表')
  }
  else if (checkoutList.value.length > 0) {
    const printList = list.value.filter((item: ITaskList) => checkoutList.value.includes(item.sampleId))
    printJSON(printList, properties, '我的检测列表')
  }
  else {
    ElMessage.warning('无可打印内容')
  }
}

// 点击批量收入
const scanSampleRef = ref()
const batchScan = () => {
  scanSampleRef.value.initDialog()
}
// 对列表中样品批量收入
const scanOver = function (list: { sampleId: string; orderId: string }) {
  // TODO:批量收入
  scanSampleRef.value.closeDialog()
  fetchData()
}

// 收入
const takeIn = function (row: ITaskList) {
  ElMessageBox.confirm(
    '确认收入该样品吗？',
    '提示',
    { confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning' },
  ).then(() => {
    // 收入样品
  })
}

// 退回
const rollbackRef = ref()
const rollback = function (row: ITaskList) {
  rollbackRef.value.initDialog(row)
}

// 捡完
const mearsureOver = function (row: ITaskList) {
  ElMessageBox.confirm(
    '确认完成该样品检测吗？',
    '提示',
    { confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning' },
  ).then(() => {
    // TODO: 完成检测
  })
}

// 点击批量捡完
const scanOverRef = ref()
const batchOverScan = () => {
  scanOverRef.value.initDialog()
}
// 对列表中样品批量捡完
const scanMeasureOver = function (list: { sampleId: string; orderId: string }) {
  // TODO:批量收入
  scanOverRef.value.closeDialog()
  fetchData()
}

// 选择按钮变更
watch(currentMenu, (val: string) => {
  listQuery.value.measureStatus = val
  fetchData(false)
})

fetchData(false)
</script>

<template>
  <app-container>
    <div class="float-radio-buttons">
      <!-- 三级菜单 -->
      <el-radio-group v-model="currentMenu">
        <el-radio-button v-for="item in menus" :key="item.name" :label="item.value">
          {{ item.name }}
        </el-radio-button>
      </el-radio-group>
    </div>
    <search-area
      :need-clear="true"
      @search="searchList" @clear="clearList"
    >
      <search-item>
        <el-input
          v-model.trim="listQuery.sampleNo"
          placeholder="样品编号"
          class="short-input"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.sampleNo"
          placeholder="样品名称"
          clearable
          class="short-input"
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.sampleNo"
          placeholder="委托书编号"
          clearable
          class="short-input"
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.sampleNo"
          placeholder="委托方代码"
          class="short-input"
          clearable
        />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="timeRange"
          type="datetimerange"
          range-separator="到"
          format="YYYY-MM-DD"
          value-format="YYYY-MM-DD"
          start-placeholder="应检完开始时间"
          end-placeholder="应检完结束时间"
          style="width: 280px;"
        />
      </search-item>
      <search-item>
        <el-select v-model="listQuery.isUrgent" placeholder="是否加急" style="width: 120px;" clearable>
          <el-option label="是" value="1" />
          <el-option label="否" value="0" />
        </el-select>
      </search-item>
      <search-item>
        <el-select v-model="listQuery.sampleBelong" placeholder="样品属性" style="width: 120px;" clearable>
          <el-option v-for="item in sampleBelongList" :key="item.id" :label="item.name" :value="item.value" />
        </el-select>
      </search-item>
    </search-area>
    <table-container>
      <template #btns-right>
        <icon-button v-if="listQuery.measureStatus === '2'" icon="icon-scan" title="扫描收入" type="primary" @click="batchScan" />
        <icon-button v-if="listQuery.measureStatus === '3'" icon="icon-scan" title="扫描检完" type="primary" @click="batchOverScan" />
        <icon-button v-if="proxy.hasPerm('/meter/customer/export')" icon="icon-export" title="导出" type="primary" @click="exportAll" />
        <icon-button v-if="proxy.hasPerm('/meter/customer/export')" icon="icon-print" title="打印" type="primary" @click="printList" />
      </template>
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery"
        :list-loading="loadingTable" is-showmulti-select @change="changePage" @multi-select="handleSelectionChange"
      >
        <template #columns>
          <el-table-column label="操作" align="center" fixed="right" width="120">
            <template #default="{ row }">
              <el-button size="small" link type="primary" @click="handleDetail(row)">
                详情
              </el-button>
              <el-button v-if="listQuery.measureStatus === '2'" size="small" type="primary" link @click="takeIn(row)">
                收入
              </el-button>
              <el-button v-if="listQuery.measureStatus === '2'" size="small" type="primary" link @click="rollback(row)">
                退回
              </el-button>
              <el-button v-if="listQuery.measureStatus === '3'" size="small" type="primary" link @click="rollback(row)">
                检测完成
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
      <!-- 退回弹窗 -->
      <rollback-dialog ref="rollbackRef" @on-success="fetchData(true)" />
      <!-- 批量收入弹窗 -->
      <scan-sample-dialog ref="scanSampleRef" @confirm="scanOver" />
      <!-- 批量捡完弹窗 -->
      <scan-sample-dialog ref="scanOverRef" title="批量捡完" @confirm="scanMeasureOver" />
    </table-container>
  </app-container>
</template>

<style lang="scss" scoped>
.short-input {
  width: 160px;
}
</style>
